from .tokensets import _token_set_register
from .tokenset_basic_v2 import TokenSet_BASICv2


_simons_basic_tokens = (
    ("HIRES", b'\x64\x01'),
    ("PLOT", b'\x64\x02'),
    ("LINE", b'\x64\x03'),
    ("BLOCK", b'\x64\x04'),
    ("FCHR", b'\x64\x05'),
    ("FCOL", b'\x64\x06'),
    ("FILL", b'\x64\x07'),
    ("REC", b'\x64\x08'),
    ("ROT", b'\x64\x09'),
    ("DRAW", b'\x64\x0A'),
    ("CHAR", b'\x64\x0B'),
    ("HI COL", b'\x64\x0C'),
    ("INV", b'\x64\x0D'),
    ("FRAC", b'\x64\x0E'),
    ("MOVE", b'\x64\x0F'),
    ("PLACE", b'\x64\x10'),
    ("UPB", b'\x64\x11'),
    ("UPW", b'\x64\x12'),
    ("LEFTW", b'\x64\x13'),
    ("LEFTB", b'\x64\x14'),
    ("DOWNB", b'\x64\x15'),
    ("DOWNW", b'\x64\x16'),
    ("RIGHTB", b'\x64\x17'),
    ("RIGHTW", b'\x64\x18'),
    ("MULTI", b'\x64\x19'),
    ("COLOUR", b'\x64\x1A'),
    ("MMOB", b'\x64\x1B'),
    ("BFLASH", b'\x64\x1C'),
    ("MOB SET", b'\x64\x1D'),
    ("MUSIC", b'\x64\x1E'),
    ("FLASH", b'\x64\x1F'),
    ("REPEAT", b'\x64\x20'),
    ("PLAY", b'\x64\x21'),
    ("CENTRE", b'\x64\x23'),
    ("ENVELOPE", b'\x64\x24'),
    ("CGOTO", b'\x64\x25'),
    ("WAVE", b'\x64\x26'),
    ("FETCH", b'\x64\x27'),
    ("AT(", b'\x64\x28'),
    ("UNTIL", b'\x64\x29'),
    ("USE", b'\x64\x2C'),
    ("GLOBAL", b'\x64\x2E'),
    ("RESET", b'\x64\x30'),
    ("PROC", b'\x64\x31'),
    ("CALL", b'\x64\x32'),
    ("EXEC", b'\x64\x33'),
    ("END PROC", b'\x64\x34'),
    ("EXIT", b'\x64\x35'),
    ("END LOOP", b'\x64\x36'),
    ("ON KEY", b'\x64\x37'),
    ("DISABLE", b'\x64\x38'),
    ("RESUME", b'\x64\x39'),
    ("LOOP", b'\x64\x3A'),
    ("DELAY", b'\x64\x3B'),
    ("SECURE", b'\x64\x40'),
    ("DISAPA", b'\x64\x41'),
    ("CIRCLE", b'\x64\x42'),
    ("ON ERROR", b'\x64\x43'),
    ("NO ERROR", b'\x64\x44'),
    ("LOCAL", b'\x64\x45'),
    ("RCOMP", b'\x64\x46'),
    ("ELSE", b'\x64\x47'),
    ("RETRACE", b'\x64\x48'),
    ("TRACE", b'\x64\x49'),
    ("DIR", b'\x64\x4A'),
    ("PAGE", b'\x64\x4B'),
    ("DUMP", b'\x64\x4C'),
    ("FIND", b'\x64\x4D'),
    ("OPTION", b'\x64\x4E'),
    ("AUTO", b'\x64\x4F'),
    ("OLD", b'\x64\x50'),
    ("JOY", b'\x64\x51'),
    ("MOD", b'\x64\x52'),
    ("DIV", b'\x64\x53'),
    ("DUP", b'\x64\x55'),
    ("INKEY", b'\x64\x56'),
    ("INST", b'\x64\x57'),
    ("TEST", b'\x64\x58'),
    ("LIN", b'\x64\x59'),
    ("EXOR", b'\x64\x5A'),
    ("INSERT", b'\x64\x5B'),
    ("POT", b'\x64\x5C'),
    ("PENX", b'\x64\x5D'),
    ("PENY", b'\x64\x5F'),
    ("SOUND", b'\x64\x60'),
    ("GRAPHICS", b'\x64\x61'),
    ("DESIGN", b'\x64\x62'),
    ("RLOCMOB", b'\x64\x63'),
    ("CMOB", b'\x64\x64'),
    ("BCKGNDS", b'\x64\x65'),
    ("PAUSE", b'\x64\x66'),
    ("NRM", b'\x64\x67'),
    ("MOB OFF", b'\x64\x68'),
    ("OFF", b'\x64\x69'),
    ("ANGL", b'\x64\x6A'),
    ("ARC", b'\x64\x6B'),
    ("COLD", b'\x64\x6C'),
    ("SCRSV", b'\x64\x6D'),
    ("SCRLD", b'\x64\x6E'),
    ("TEXT", b'\x64\X6F'),
    ("CSET", b'\x64\x70'),
    ("VOL", b'\x64\x71'),
    ("DISK", b'\x64\x72'),
    ("HRDCPY", b'\x64\x73'),
    ("KEY", b'\x64\x74'),
    ("PAINT", b'\x64\x75'),
    ("LOW COL", b'\x64\x76'),
    ("COPY", b'\x64\x77'),
    ("MERGE", b'\x64\x78'),
    ("RENUMBER", b'\x64\x79'),
    ("MEM", b'\x64\x7A'),
    ("DETECT", b'\x64\x7B'),
    ("CHECK", b'\x64\x7C'),
    ("DISPLAY", b'\x64\x7D'),
    ("ERR", b'\x64\x7E'),
    ("OUT", b'\x64\x7F')
)


class TokenSet_Simons_BASIC(TokenSet_BASICv2):
    """Tokens used by Simons Basic (C64)."""
    def __init__(self):
        super().__init__()
        self.add_tokens(_simons_basic_tokens)


_token_set_register['simons-basic'] = TokenSet_Simons_BASIC()
